%%******************************************************
%% Run this script in Matlab command window to generate some mex files
%%  
%% Copyright (c) 2021 by
%% Ling Liang, Xudong Li, Defeng Sun, Kim-Chuan Toh
%%******************************************************

   function Installmex(recompile) 

   if (nargin == 0); recompile = 0; end
   matlabversion = sscanf(version,'%f');
   matlabversion = matlabversion(1);
   tmp = version('-release'); 
   matlabrelease = str2num(tmp(1:4));
%%
   mexcmd = 'mex -O  -largeArrayDims  -output ';    
%%
   if (matlabversion < 7.3)  && (matlabrelease <= 2008)
      error(' needs MATLAB version 7.4 and above'); 
   end
   fsp = filesep;
   libstr = [];   

   curdir = pwd;  
   fprintf(' current directory is:  %s\n',curdir); 
%%
%% generate mex files in mexfun
%%
   clear fname

   src = [curdir,fsp,'mexfun']; 
   eval(['cd ','mexfun']); 
   fprintf ('\n Now compiling the mexFunctions in:\n'); 
   fprintf (' %s\n',src);       
   %%
   fname{1} = 'mexbwsolve';
   fname{2} = 'mexfwsolve';
   fname{3} = 'mextriang'; 
   fname{4} = 'mexMatvec';   
   fname{5} = 'mexFnorm';   

   existfile = zeros(1,length(fname));
   for k = 1:length(fname)
      existfile(k) = exist([fname{k},'.',mexext]);   
   end
   for k = 1:length(fname)
       if recompile || ~existfile(k)
          cmd([mexcmd,fname{k},'  ',fname{k},'.c  ',libstr]);  
       end
   end      
   fprintf ('\n Compilation of mexFunctions completed.\n'); 
   cd .. 
   %cd ..
%%***********************************************
   function cmd(s) 
   
   fprintf(' %s\n',s); 
   eval(s); 
%%***********************************************
