function [breakyes, msg] = checkTerminationPhaseOne(ws, iter, options, param)
    breakyes = 0;
    msg = [];
    if isfield(options,'stopTolPhaseOne')
        stopTol = options.stopTolPhaseOne;
    else
        stopTol = options.stopTol;
    end
    relkkt = max([ws.maxfeasorg, ws.relerrQorg, ws.relerrCorg, abs(ws.relgaporg)]);
    if rem(iter, options.iterComputeQx) == 0
        if relkkt < stopTol %&& max([ws.relerrQorg, ws.relerrCorg, abs(ws.relgaporg)]) < 1e-3
            breakyes = 1;
            msg = 'terminated';
        end
    end
    if iter == options.maxIterPhaseOne
        breakyes = 2;
        msg = 'maximum iteration reached';
    end

    if iter <= 200
        printIter = 50;
    elseif iter <= 2000
        printIter = 100;
    else
        printIter = 500;
    end
    if (rem(iter, printIter) == 1 && options.printYes) || breakyes 
        fprintf('\n %5d| %- 9.8e %- 9.8e %- 2.1e| %2.1e %2.1e %2.1e %2.1e| %2.1e %3.2f|', ...
            iter, ...
            ws.primobjorg, ws.dualobjorg, ws.relgaporg, ...
            ws.primfeasorg, ws.dualfeasorg, ws.relerrQorg, ws.relerrCorg, ...
            param.sigma, param.gamma);
    end
end