function [breakyes, msg] = checkTerminationPhaseTwo(ws, iter, options, param)
    breakyes = 0;
    msg = [];
    relkkt = max([ws.maxfeasorg, ws.relerrQorg, ws.relerrCorg, abs(ws.relgaporg)]);
    if relkkt < options.stopTol %&& max([ws.relerrQorg, ws.relerrCorg,1e-2*abs(ws.relgaporg)]) < 1e-6
        breakyes = 1;
        msg = 'terminated';
    end
    if iter == options.maxIterPhaseTwo
        breakyes = 2;
        msg = 'maximum iteration reached';
    end

    if options.printYes || breakyes
        if ~isfield(param, 'tausig'); tau = inf; else; tau = param.tausig*param.sigma; end 
        fprintf('\n %5d| %- 9.8e %- 9.8e %- 2.1e| %2.1e %2.1e %2.1e %2.1e| %2.1e %2.1e|', ...
            iter, ...
            ws.primobjorg, ws.dualobjorg, ws.relgaporg, ...
            ws.primfeasorg, ws.dualfeasorg, ws.relerrQorg, ws.relerrCorg, ...
            param.sigma, tau);
    end
end