function [L,QI] = mycholQ(Q,n,sigma)
%%
%% chol decompostion for I + sigma*Q
%%
QI = sigma*Q + speye(n);
%%
if (nnz(QI) < 0.3*n*n); use_spchol=1; else; use_spchol=0; end
if (use_spchol)
    [L.R,L.p,L.perm] = chol(QI,'vector');
    L.Rt = L.R';
    L.matfct_options = 'spchol';
else
    if issparse(QI); QI = full(QI); end
    L.matfct_options = 'chol';
    L.perm = 1:n;
    [L.R,indef] = chol(QI);
    if (indef)
        fprintf('\n mycholQ: Matrix not positive definite');
    end
end
dd = diag(QI);
L.isdiagonal= false;
if  (norm(QI-spdiags(dd,0,n,n),'fro') < 1e-15*norm(dd))
    L.isdiagonal = false;
    L.diagonal = dd;
end
%%***********************************************************