%%**********************************************************************
%% solve A*q = r.
%%**********************************************************************
function q = mylinsysolve(L,r)
q = zeros(size(r));
for k = 1:size(r, 2)
    if (L.isdiagonal)
        q(:,k) = r(:,k)./L.diagonal;
    else
        if strcmp(L.matfct_options,'chol')
            q(L.perm,k) = mextriang(L.R, mextriang(L.R, r(L.perm, k), 2) ,1);
        elseif strcmp(L.matfct_options,'spchol')
            q(L.perm,k) = mexbwsolve(L.Rt, mexfwsolve(L.R, r(L.perm,k)));
        end
    end
end
%%**********************************************************************
