function [Qinput, AA, bb, cc, LL, UU] = standardQP(Q, c, AE, AI, bE, bI, L, U)
% transform the problem into the standard QP
if ~isempty(bI)
    if norm(bI) < 1e5; eg = 2; else; eg = 1; end
    lb = length(bE); lbb = length(bI); lc = size(Q, 1);
    if eg == 1
        Qinput = sparse([[Q, sparse(lc, lbb)]; sparse(lbb, lc + lbb)]);
        cc = full([c; zeros(lbb, 1)]);
        normAI = max(1e-3, min(1e3, sqrt(sum(AI.*AI, 2))));
        DD = spdiags(normAI, 0, lbb, lbb);
        AA = sparse([[AE, sparse(lb, lbb)]; [AI, -DD]]);
        bb = full([bE; zeros(lbb, 1)]);
        LL = full([L; DD\(-1e20*ones(lbb, 1))]);
        UU = full([U; DD\ bI]);
    elseif eg== 2
        Qinput = sparse([[Q, sparse(lc, lbb)]; sparse(lbb, lc + lbb)]);
        cc = full([c; zeros(lbb, 1)]);
        normAI = max(1e-3, min(1e3, sqrt(sum(AI.*AI, 2))));
        DD = spdiags(normAI, 0, lbb, lbb);
        AA = sparse([[AE, sparse(lb, lbb)]; [AI, DD]]);
        bb = full([bE; bI]);
        LL = full([L; DD\zeros(lbb, 1)]);
        UU = full([U; DD\ones(lbb, 1)*1e20]);
    end
else
    Qinput = Q; AA = AE; cc = c; bb = bE; LL = L; UU = U;
end

% remove zero columns
idxcolsmall = find(sqrt(sum(AA .* AA, 1)) < 1e-15);
idxcolkeep = setdiff(1:length(cc), idxcolsmall);
Qinput = Qinput(idxcolkeep, idxcolkeep);
%Qinput = Qinput + 1e-12*speye(size(Qinput));
if ~isempty(AA); AA = AA(:, idxcolkeep); end
cc = cc(idxcolkeep);
LL = LL(idxcolkeep);
UU = UU(idxcolkeep);
end