function ws = workSpace(prob, sol, scl, ws)
    if nargin < 4
        ws.Rd = sol.z - sol.Qw - prob.c;
        if prob.existA
            ws.Aty = prob.At * sol.y;
            ws.Rd = ws.Rd + ws.Aty;
        end
    end
    if prob.existA
        ws.Rp = prob.b - prob.A * sol.x;
    else
        ws.Rp = 0;
    end
    ws.primfeas = norm(ws.Rp) / (1+norm(prob.b));
    ws.dualfeas = norm(ws.Rd) / (1+norm(prob.c));
    ws.maxfeas = max(ws.primfeas, ws.dualfeas);
    ws.normx = norm(sol.x);
    ws.normz = norm(sol.z);
    ws.normQx = norm(sol.Qx);
    ws.normQw = norm(sol.Qw);
    ws.relerrQ = norm(sol.Qx - sol.Qw) / (1+max(0*norm(prob.c), ws.normQx+ws.normQw));
    ws.relerrC = norm(sol.x - projBox(sol.x-sol.z,prob.L,prob.U)) / (1+max(0*norm(prob.c),ws.normx+ws.normz));

    ws.xorg = (sol.x .* scl.cA) * scl.bscale;
    ws.zorg = (sol.z ./ scl.cA) * scl.cscale;
    ws.normxorg = norm(ws.xorg);
    ws.normzorg = norm(ws.zorg);
    ws.Qxorg = (sol.Qx ./ scl.cA) .* scl.cscale;
    ws.Qworg = (sol.Qw ./ scl.cA) .* scl.cscale;
    ws.normQxorg = norm(ws.Qxorg);
    ws.normQworg = norm(ws.Qworg);
    ws.primfeasorg = norm((ws.Rp ./ scl.rA) .* scl.bscale) / (1+prob.normborg);
    ws.dualfeasorg = norm((ws.Rd ./ scl.cA) .* scl.cscale) / (1+prob.normcorg);
    ws.maxfeasorg = max(ws.primfeasorg, ws.dualfeasorg);
    ws.relerrQorg = norm(ws.Qxorg - ws.Qworg) / (1+max(0*prob.normcorg, ws.normQxorg+ws.normQworg));
    ws.relerrCorg = norm(ws.xorg-projBox(ws.xorg-ws.zorg,prob.Lorg,prob.Uorg))/...
        (1+max(0*prob.normcorg, ws.normxorg+ws.normzorg));

    ws.primobj = 0.5*sum(sol.x .* sol.Qx) + sum(prob.c .* sol.x);
    ws.dualobj = -0.5*sum(sol.w .* sol.Qw) + sum(sol.x .* sol.z);
    if prob.existA
        ws.dualobj = ws.dualobj + sum(prob.b .* sol.y);
    end
    ws.relgap = (ws.primobj - ws.dualobj) / (1+abs(ws.primobj)+abs(ws.dualobj));
    ws.primobjorg = ws.primobj * scl.objscale;
    ws.dualobjorg = ws.dualobj * scl.objscale;
    ws.relgaporg = (ws.primobjorg - ws.dualobjorg) / (1+abs(ws.primobjorg)+abs(ws.dualobjorg));
end